--- old/usr/src/common/crypto/aes/aes_impl.c	Thu Apr 30 20:52:29 2015
+++ new/usr/src/common/crypto/aes/aes_impl.c	Thu Apr 30 20:52:29 2015
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
  */
 
 #include <sys/types.h>
@@ -30,6 +31,7 @@
 #ifndef	_KERNEL
 #include <strings.h>
 #include <stdlib.h>
+#include <sys/note.h>
 #endif	/* !_KERNEL */
 
 #ifdef __amd64
@@ -94,8 +96,8 @@
 extern void aes_decrypt_impl(const uint32_t rk[], int Nr, const uint32_t ct[4],
 	uint32_t pt[4]);
 
-#define	AES_ENCRYPT_IMPL(a, b, c, d, e)	aes_encrypt_impl(a, b, c, d)
-#define	AES_DECRYPT_IMPL(a, b, c, d, e)	aes_decrypt_impl(a, b, c, d)
+#define	AES_ENCRYPT_IMPL(a, b, c, d)	aes_encrypt_impl(a, b, c, d)
+#define	AES_DECRYPT_IMPL(a, b, c, d)	aes_decrypt_impl(a, b, c, d)
 
 #elif defined(__amd64)
 
@@ -118,17 +120,37 @@
 	const uint32_t pt[4], uint32_t ct[4]);
 extern void aes_decrypt_intel(const uint32_t rk[], int Nr,
 	const uint32_t ct[4], uint32_t pt[4]);
+extern void aes_encrypt_intel8(const uint32_t rk[], int Nr,
+	const void *pt, void *ct);
+extern void aes_decrypt_intel8(const uint32_t rk[], int Nr,
+	const void *ct, void *pt);
+extern void aes_encrypt_cbc_intel8(const uint32_t rk[], int Nr,
+	const void *pt, void *ct, const void *iv);
+extern void aes_ctr_intel8(const uint32_t rk[], int Nr,
+	const void *input, void *output, uint64_t counter_upper_BE,
+	uint64_t counter_lower_LE);
+extern void aes_xor_intel(const uint8_t *, uint8_t *);
 
-static int intel_aes_instructions_present(void);
+static inline int intel_aes_instructions_present(void);
 
-#define	AES_ENCRYPT_IMPL(a, b, c, d, e) rijndael_encrypt(a, b, c, d, e)
-#define	AES_DECRYPT_IMPL(a, b, c, d, e) rijndael_decrypt(a, b, c, d, e)
+#ifdef	_KERNEL
+/*
+ * Some form of floating-point acceleration is available, so declare these.
+ * The implementations will be in a platform-specific assembly file (e.g.
+ * amd64/aes_intel.s for SSE2/AES-NI).
+ */
+extern void aes_accel_save(void *savestate);
+extern void aes_accel_restore(void *savestate);
+#endif	/* _KERNEL */
 
 #else /* Generic C implementation */
-
-#define	AES_ENCRYPT_IMPL(a, b, c, d, e)	rijndael_encrypt(a, b, c, d)
-#define	AES_DECRYPT_IMPL(a, b, c, d, e)	rijndael_decrypt(a, b, c, d)
+static void rijndael_encrypt(const uint32_t rk[], int Nr, const uint32_t pt[4],
+    uint32_t ct[4]);
+static void rijndael_decrypt(const uint32_t rk[], int Nr, const uint32_t pt[4],
+    uint32_t ct[4]);
 #define	rijndael_key_setup_enc_raw	rijndael_key_setup_enc
+#define	AES_ENCRYPT_IMPL(a, b, c, d)	rijndael_encrypt(a, b, c, d)
+#define	AES_DECRYPT_IMPL(a, b, c, d)	rijndael_decrypt(a, b, c, d)
 #endif	/* sun4u || __amd64 */
 
 #if defined(_LITTLE_ENDIAN) && !defined(__amd64)
@@ -1140,16 +1162,15 @@
 static void
 aes_setupkeys(aes_key_t *key, const uint32_t *keyarr32, int keybits)
 {
+	AES_ACCEL_SAVESTATE(savestate);
+	aes_accel_enter(savestate);
+
 	if (intel_aes_instructions_present()) {
-		key->flags = INTEL_AES_NI_CAPABLE;
-		KPREEMPT_DISABLE;
 		key->nr = rijndael_key_setup_enc_intel(&(key->encr_ks.ks32[0]),
 		    keyarr32, keybits);
 		key->nr = rijndael_key_setup_dec_intel(&(key->decr_ks.ks32[0]),
 		    keyarr32, keybits);
-		KPREEMPT_ENABLE;
 	} else {
-		key->flags = 0;
 		key->nr = rijndael_key_setup_enc_amd64(&(key->encr_ks.ks32[0]),
 		    keyarr32, keybits);
 		key->nr = rijndael_key_setup_dec_amd64(&(key->decr_ks.ks32[0]),
@@ -1156,64 +1177,10 @@
 		    keyarr32, keybits);
 	}
 
+	aes_accel_exit(savestate);
 	key->type = AES_32BIT_KS;
 }
 
-/*
- * Encrypt one block of data. The block is assumed to be an array
- * of four uint32_t values, so copy for alignment (and byte-order
- * reversal for little endian systems might be necessary on the
- * input and output byte streams.
- * The size of the key schedule depends on the number of rounds
- * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
- *
- * Parameters:
- * rk		Key schedule, of aes_ks_t (60 32-bit integers)
- * Nr		Number of rounds
- * pt		Input block (plain text)
- * ct		Output block (crypto text).  Can overlap with pt
- * flags	Indicates whether we're on Intel AES-NI-capable hardware
- */
-static void
-rijndael_encrypt(const uint32_t rk[], int Nr, const uint32_t pt[4],
-    uint32_t ct[4], int flags) {
-	if (flags & INTEL_AES_NI_CAPABLE) {
-		KPREEMPT_DISABLE;
-		aes_encrypt_intel(rk, Nr, pt, ct);
-		KPREEMPT_ENABLE;
-	} else {
-		aes_encrypt_amd64(rk, Nr, pt, ct);
-	}
-}
-
-/*
- * Decrypt one block of data. The block is assumed to be an array
- * of four uint32_t values, so copy for alignment (and byte-order
- * reversal for little endian systems might be necessary on the
- * input and output byte streams.
- * The size of the key schedule depends on the number of rounds
- * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
- *
- * Parameters:
- * rk		Key schedule, of aes_ks_t (60 32-bit integers)
- * Nr		Number of rounds
- * ct		Input block (crypto text)
- * pt		Output block (plain text). Can overlap with pt
- * flags	Indicates whether we're on Intel AES-NI-capable hardware
- */
-static void
-rijndael_decrypt(const uint32_t rk[], int Nr, const uint32_t ct[4],
-    uint32_t pt[4], int flags) {
-	if (flags & INTEL_AES_NI_CAPABLE) {
-		KPREEMPT_DISABLE;
-		aes_decrypt_intel(rk, Nr, ct, pt);
-		KPREEMPT_ENABLE;
-	} else {
-		aes_decrypt_amd64(rk, Nr, ct, pt);
-	}
-}
-
-
 #else /* generic C implementation */
 
 /*
@@ -1622,7 +1589,22 @@
 	aes_setupkeys(newbie, keyarr.ka32, keyBits);
 }
 
+#if	defined(__amd64) && defined(_KERNEL)
+void
+aes_accel_enter(void *savestate)
+{
+	KPREEMPT_DISABLE;
+	aes_accel_save(savestate);
+}
 
+void
+aes_accel_exit(void *savestate)
+{
+	aes_accel_restore(savestate);
+	KPREEMPT_ENABLE;
+}
+#endif	/* defined(__amd64) && defined(_KERNEL) */
+
 /*
  * Encrypt one block using AES.
  * Align if needed and (for x86 32-bit only) byte-swap.
@@ -1637,12 +1619,21 @@
 {
 	aes_key_t	*ksch = (aes_key_t *)ks;
 
+#ifdef	__amd64
+	if (intel_aes_instructions_present())
+		aes_encrypt_intel(&ksch->encr_ks.ks32[0], ksch->nr,
+		    /* LINTED:  pointer alignment */
+		    (uint32_t *)pt, (uint32_t *)ct);
+	else
+		aes_encrypt_amd64(&ksch->encr_ks.ks32[0], ksch->nr,
+		    /* LINTED:  pointer alignment */
+		    (uint32_t *)pt, (uint32_t *)ct);
+#else	/* !__amd64 */
 #ifndef	AES_BYTE_SWAP
 	if (IS_P2ALIGNED2(pt, ct, sizeof (uint32_t))) {
-		/* LINTED:  pointer alignment */
 		AES_ENCRYPT_IMPL(&ksch->encr_ks.ks32[0], ksch->nr,
 		    /* LINTED:  pointer alignment */
-		    (uint32_t *)pt, (uint32_t *)ct, ksch->flags);
+		    (uint32_t *)pt, (uint32_t *)ct);
 	} else {
 #endif
 		uint32_t buffer[AES_BLOCK_LEN / sizeof (uint32_t)];
@@ -1656,10 +1647,10 @@
 		buffer[1] = htonl(*(uint32_t *)(void *)&pt[4]);
 		buffer[2] = htonl(*(uint32_t *)(void *)&pt[8]);
 		buffer[3] = htonl(*(uint32_t *)(void *)&pt[12]);
-#endif
+#endif	/* byte swap */
 
 		AES_ENCRYPT_IMPL(&ksch->encr_ks.ks32[0], ksch->nr,
-		    buffer, buffer, ksch->flags);
+		    buffer, buffer);
 
 		/* Copy result from buffer to output block */
 #ifndef	AES_BYTE_SWAP
@@ -1671,7 +1662,9 @@
 		*(uint32_t *)(void *)&ct[4] = htonl(buffer[1]);
 		*(uint32_t *)(void *)&ct[8] = htonl(buffer[2]);
 		*(uint32_t *)(void *)&ct[12] = htonl(buffer[3]);
-#endif
+#endif	/* byte swap */
+#endif	/* !__amd64 */
+
 	return (CRYPTO_SUCCESS);
 }
 
@@ -1690,12 +1683,21 @@
 {
 	aes_key_t	*ksch = (aes_key_t *)ks;
 
+#ifdef	__amd64
+	if (intel_aes_instructions_present())
+		aes_decrypt_intel(&ksch->decr_ks.ks32[0], ksch->nr,
+		    /* LINTED:  pointer alignment */
+		    (uint32_t *)ct, (uint32_t *)pt);
+	else
+		aes_decrypt_amd64(&ksch->decr_ks.ks32[0], ksch->nr,
+		    /* LINTED:  pointer alignment */
+		    (uint32_t *)ct, (uint32_t *)pt);
+#else	/* !__amd64 */
 #ifndef	AES_BYTE_SWAP
 	if (IS_P2ALIGNED2(ct, pt, sizeof (uint32_t))) {
-		/* LINTED:  pointer alignment */
 		AES_DECRYPT_IMPL(&ksch->decr_ks.ks32[0], ksch->nr,
 		    /* LINTED:  pointer alignment */
-		    (uint32_t *)ct, (uint32_t *)pt, ksch->flags);
+		    (uint32_t *)ct, (uint32_t *)pt);
 	} else {
 #endif
 		uint32_t buffer[AES_BLOCK_LEN / sizeof (uint32_t)];
@@ -1709,10 +1711,10 @@
 		buffer[1] = htonl(*(uint32_t *)(void *)&ct[4]);
 		buffer[2] = htonl(*(uint32_t *)(void *)&ct[8]);
 		buffer[3] = htonl(*(uint32_t *)(void *)&ct[12]);
-#endif
+#endif	/* byte swap */
 
 		AES_DECRYPT_IMPL(&ksch->decr_ks.ks32[0], ksch->nr,
-		    buffer, buffer, ksch->flags);
+		    buffer, buffer);
 
 		/* Copy result from buffer to output block */
 #ifndef	AES_BYTE_SWAP
@@ -1724,13 +1726,227 @@
 	*(uint32_t *)(void *)&pt[4] = htonl(buffer[1]);
 	*(uint32_t *)(void *)&pt[8] = htonl(buffer[2]);
 	*(uint32_t *)(void *)&pt[12] = htonl(buffer[3]);
-#endif
+#endif	/* byte swap */
+#endif	/* !__amd64 */
 
 	return (CRYPTO_SUCCESS);
 }
 
+#define	ECB_LOOP(ciph_func)						\
+	do {								\
+		for (; i < length; i += AES_BLOCK_LEN)			\
+			ciph_func;					\
+		_NOTE(CONSTCOND)					\
+	} while (0)
+#define	ECB_LOOP_4P(ciph_func, enc_or_dec, in, out)			\
+	ECB_LOOP(ciph_func(&ksch->enc_or_dec ## r_ks.ks32[0],		\
+	    ksch->nr, (void *)&in[i], (void *)&out[i]))
+#define	ECB_LOOP_3P(ciph_func, in, out)					\
+	ECB_LOOP(ciph_func(ksch, (void *)&in[i], (void *)&out[i]))
 
+#ifdef	__amd64
+#define	ECB_INTEL_IMPL(enc_or_dec, in, out)				\
+	do {								\
+		if (intel_aes_instructions_present()) {			\
+			/* first use the accelerated function */	\
+			for (; i + 8 * AES_BLOCK_LEN <= length;		\
+			    i += 8 * AES_BLOCK_LEN)			\
+				aes_ ## enc_or_dec ## rypt_intel8(	\
+				    &ksch->enc_or_dec ## r_ks.ks32[0],	\
+				    ksch->nr, &in[i], &out[i]);		\
+			/* finish off the remainder per-block */	\
+			ECB_LOOP_4P(aes_ ## enc_or_dec ## rypt_intel,	\
+			    enc_or_dec,	in, out);			\
+		} else {						\
+			ECB_LOOP_4P(aes_ ## enc_or_dec ## rypt_amd64,	\
+			    enc_or_dec, in, out);			\
+		}							\
+		_NOTE(CONSTCOND)					\
+	} while (0)
+#endif	/* __amd64 */
+
 /*
+ * Perform AES ECB encryption on a sequence of blocks. On x86-64 CPUs with
+ * the AES-NI extension, this performs the encryption in increments of 8
+ * blocks at a time, exploiting instruction parallelism more efficiently.
+ * On other platforms, this simply encrypts the blocks in sequence.
+ */
+int
+aes_encrypt_ecb(const void *ks, const uint8_t *pt, uint8_t *ct, uint64_t length)
+{
+	aes_key_t *ksch = (aes_key_t *)ks;
+	uint64_t i = 0;
+
+#ifdef	__amd64
+	ECB_INTEL_IMPL(enc, pt, ct);
+#elif	defined(sun4u)
+	ECB_LOOP_4P(aes_encrypt_impl, enc, pt, ct);
+#else	/* Generic C implementation */
+	ECB_LOOP_3P((void) aes_encrypt_block, pt, ct);
+#endif	/* Generic C implementation */
+
+	return (CRYPTO_SUCCESS);
+}
+
+/*
+ * Same as aes_encrypt_ecb, but performs decryption.
+ */
+int
+aes_decrypt_ecb(const void *ks, const uint8_t *ct, uint8_t *pt, uint64_t length)
+{
+	aes_key_t *ksch = (aes_key_t *)ks;
+	uint64_t i = 0;
+
+#ifdef	__amd64
+	ECB_INTEL_IMPL(dec, ct, pt);
+#elif	defined(sun4u)
+	ECB_LOOP_4P(aes_decrypt_impl, dec, ct, pt);
+#else	/* Generic C implementation */
+	ECB_LOOP_3P((void) aes_decrypt_block, ct, pt);
+#endif	/* Generic C implementation */
+
+	return (CRYPTO_SUCCESS);
+}
+#ifdef	__amd64
+#undef	ECB_INTEL_IMPL
+#endif	/* __amd64 */
+
+#undef	ECB_LOOP
+#undef	ECB_LOOP_4P
+#undef	ECB_LOOP_3P
+
+#define	CBC_LOOP(enc_func, xor_func)					\
+	do {								\
+		for (; i < length; i += AES_BLOCK_LEN) {		\
+			/* copy IV to ciphertext */			\
+			bcopy(iv, &ct[i], AES_BLOCK_LEN);		\
+			/* XOR IV with plaintext with input */		\
+			xor_func(&pt[i], &ct[i]);			\
+			/* encrypt counter in output region */		\
+			enc_func;					\
+			iv = &ct[i];					\
+		}							\
+		_NOTE(CONSTCOND)					\
+	} while (0)
+#define	CBC_LOOP_4P(enc_func, xor_func)					\
+	CBC_LOOP(enc_func(&ksch->encr_ks.ks32[0],			\
+	    ksch->nr, (void *)&ct[i], (void *)&ct[i]), xor_func)
+#define	CBC_LOOP_3P(enc_func, xor_func)					\
+	CBC_LOOP(enc_func(ksch, (void *)&ct[i], (void *)&ct[i]), xor_func)
+
+/*
+ * Encrypts a sequence of consecutive AES blocks in CBC mode. On x86-64
+ * with the AES-NI extension, the encryption is performed on 8 blocks at
+ * a time using an optimized assembly implementation, giving a speed boost
+ * of around 75%. On other platforms, this simply performs CBC encryption
+ * in sequence on the blocks.
+ *
+ * Decryption acceleration is implemented in the kernel kcf block cipher
+ * modes code (cbc.c), because that doesn't require a complete hand-tuned
+ * CBC implementation in assembly.
+ */
+int
+aes_encrypt_cbc(const void *ks, const uint8_t *pt, uint8_t *ct,
+    const uint8_t *iv, uint64_t length)
+{
+	aes_key_t *ksch = (aes_key_t *)ks;
+	size_t i = 0;
+
+#ifdef	__amd64
+	if (intel_aes_instructions_present()) {
+		for (; i + 8 * AES_BLOCK_LEN <= length;
+		    i += 8 * AES_BLOCK_LEN) {
+			aes_encrypt_cbc_intel8(&ksch->encr_ks.ks32[0],
+			    ksch->nr, &ct[i], &ct[i], iv);
+			iv = &ct[7 * AES_BLOCK_LEN];
+		}
+		CBC_LOOP_4P(aes_encrypt_intel, aes_xor_intel);
+	} else {
+		CBC_LOOP_4P(aes_encrypt_amd64, aes_xor_intel);
+	}
+#elif	defined(sun4u)
+	CBC_LOOP_4P(aes_encrypt_impl, aes_xor_block);
+#else	/* Generic C implementation */
+	CBC_LOOP_3P((void) aes_encrypt_block, aes_xor_block);
+#endif	/* Generic C implementation */
+
+	return (CRYPTO_SUCCESS);
+}
+#undef	CBC_LOOP
+#undef	CBC_LOOP_4P
+#undef	CBC_LOOP_3P
+
+#define	CTR_LOOP(enc_func, xor_func)					\
+	do {								\
+		for (; i < length; i += AES_BLOCK_LEN) {		\
+			/* set up counter in output region */		\
+			*(uint64_t *)(void *)&output[i] = counter[0];	\
+			*(uint64_t *)(void *)&output[i + 8] =		\
+			    htonll(counter[1]++);			\
+			/* encrypt counter in output region */		\
+			enc_func;					\
+			/* XOR encrypted counter with input */		\
+			xor_func(&input[i], &output[i]);		\
+		}							\
+		_NOTE(CONSTCOND)					\
+	} while (0)
+#define	CTR_LOOP_4P(enc_func, xor_func)					\
+	CTR_LOOP(enc_func(&ksch->encr_ks.ks32[0], ksch->nr,		\
+	    (void *)&output[i], (void *)&output[i]), xor_func)
+#define	CTR_LOOP_3P(enc_func, xor_func)					\
+	CTR_LOOP(enc_func(ksch, (void *)&output[i], (void *)&output[i]),\
+	    xor_func)
+/*
+ * Performs high-performance counter mode encryption and decryption on
+ * a sequence of blocks. In CTR mode, encryption and decryption are the
+ * same operation, just with the plaintext and ciphertext reversed:
+ * plaintext = CTR(CTR(plaintext, K), K)
+ * Blocks also do not interdepend on each other, so it is an excellent
+ * mode when high performance is required and data authentication/integrity
+ * checking is provided via some other means, or isn't necessary.
+ *
+ * On x86-64 with the AES-NI extension, this code performs CTR mode
+ * encryption in parallel on 8 blocks at a time and can provide in
+ * excess of 3GB/s/core of encryption/decryption performance (<1 CPB).
+ */
+int
+aes_ctr_mode(const void *ks, const uint8_t *input, uint8_t *output,
+    uint64_t length, uint64_t counter[2])
+{
+	aes_key_t *ksch = (aes_key_t *)ks;
+	uint64_t i = 0;
+
+	// swap lower part to host order for computations
+	counter[1] = ntohll(counter[1]);
+
+#ifdef	__amd64
+	if (intel_aes_instructions_present()) {
+		/* first use the wide-register accelerated function */
+		for (; i + 8 * AES_BLOCK_LEN <= length;
+		    i += 8 * AES_BLOCK_LEN) {
+			aes_ctr_intel8(&ksch->encr_ks.ks32[0], ksch->nr,
+			    &input[i], &output[i], counter[0], counter[1]);
+			counter[1] += 8;
+		}
+		/* finish off the remainder using the slow per-block method */
+		CTR_LOOP_4P(aes_encrypt_intel, aes_xor_intel);
+	} else {
+		CTR_LOOP_4P(aes_encrypt_amd64, aes_xor_intel);
+	}
+#elif	defined(sun4u)
+	CTR_LOOP_4P(aes_encrypt_impl, aes_xor_block);
+#else	/* Generic C implementation */
+	CTR_LOOP_3P((void) aes_encrypt_block, aes_xor_block);
+#endif	/* Generic C implementation */
+
+	// swap lower part back to big endian
+	counter[1] = htonll(counter[1]);
+
+	return (CRYPTO_SUCCESS);
+}
+#undef	CTR_LOOP
+
+/*
  * Allocate key schedule for AES.
  *
  * Return the pointer and set size to the number of bytes allocated.
@@ -1762,14 +1978,13 @@
 
 #ifdef __amd64
 /*
- * Return 1 if executing on Intel with AES-NI instructions,
- * otherwise 0 (i.e., Intel without AES-NI or AMD64).
+ * Return 1 if executing on x86-64 with AES-NI instructions, otherwise 0.
  * Cache the result, as the CPU can't change.
  *
  * Note: the userland version uses getisax().  The kernel version uses
  * global variable x86_featureset.
  */
-static int
+static inline int
 intel_aes_instructions_present(void)
 {
 	static int	cached_result = -1;
--- old/usr/src/common/crypto/aes/aes_impl.h	Thu Apr 30 20:52:29 2015
+++ new/usr/src/common/crypto/aes/aes_impl.h	Thu Apr 30 20:52:29 2015
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #ifndef	_AES_IMPL_H
 #define	_AES_IMPL_H
@@ -45,7 +48,7 @@
 /* Round constant length, in number of 32-bit elements: */
 #define	RC_LENGTH	(5 * ((AES_BLOCK_LEN) / 4 - 2))
 
-#define	AES_COPY_BLOCK(src, dst) \
+#define	AES_COPY_BLOCK_UNALIGNED(src, dst) \
 	(dst)[0] = (src)[0]; \
 	(dst)[1] = (src)[1]; \
 	(dst)[2] = (src)[2]; \
@@ -63,7 +66,7 @@
 	(dst)[14] = (src)[14]; \
 	(dst)[15] = (src)[15]
 
-#define	AES_XOR_BLOCK(src, dst) \
+#define	AES_XOR_BLOCK_UNALIGNED(src, dst) \
 	(dst)[0] ^= (src)[0]; \
 	(dst)[1] ^= (src)[1]; \
 	(dst)[2] ^= (src)[2]; \
@@ -81,6 +84,14 @@
 	(dst)[14] ^= (src)[14]; \
 	(dst)[15] ^= (src)[15]
 
+#define	AES_COPY_BLOCK_ALIGNED(src, dst) \
+	((uint64_t *)(void *)(dst))[0] = ((uint64_t *)(void *)(src))[0]; \
+	((uint64_t *)(void *)(dst))[1] = ((uint64_t *)(void *)(src))[1]
+
+#define	AES_XOR_BLOCK_ALIGNED(src, dst) \
+	((uint64_t *)(void *)(dst))[0] ^= ((uint64_t *)(void *)(src))[0]; \
+	((uint64_t *)(void *)(dst))[1] ^= ((uint64_t *)(void *)(src))[1]
+
 /* AES key size definitions */
 #define	AES_MINBITS		128
 #define	AES_MINBYTES		((AES_MINBITS) >> 3)
@@ -99,6 +110,43 @@
 #define	MAX_AES_NR		14 /* Maximum number of rounds */
 #define	MAX_AES_NB		4  /* Number of columns comprising a state */
 
+/*
+ * Architecture-specific acceleration support autodetection.
+ * Some architectures provide hardware-assisted acceleration using floating
+ * point registers, which need special handling inside of the kernel, so the
+ * macros below define the auxiliary functions needed to utilize them.
+ */
+#if	defined(__amd64) && defined(_KERNEL)
+/*
+ * Using floating point registers requires temporarily disabling kernel
+ * thread preemption, so we need to operate on small-enough chunks to
+ * prevent scheduling latency bubbles.
+ * A typical 64-bit CPU can sustain around 300-400MB/s/core even in the
+ * slowest encryption modes (CBC), which with 32k per run works out to ~100us
+ * per run. CPUs with AES-NI in fast modes (ECB, CTR, CBC decryption) can
+ * easily sustain 3GB/s/core, so the latency potential essentially vanishes.
+ */
+#define	AES_OPSZ	32768
+
+#if	defined(lint) || defined(__lint)
+#define	AES_ACCEL_SAVESTATE(name)	uint8_t name[16 * 16 + 8]
+#else	/* lint || __lint */
+#define	AES_ACCEL_SAVESTATE(name) \
+	/* stack space for xmm0--xmm15 and cr0 (16 x 128 bits + 64 bits) */ \
+	uint8_t name[16 * 16 + 8] __attribute__((aligned(16)))
+#endif	/* lint || __lint */
+
+#else	/* !defined(__amd64) || !defined(_KERNEL) */
+/*
+ * All other accel support
+ */
+#define	AES_OPSZ	((size_t)-1)
+/* On other architectures or outside of the kernel these get stubbed out */
+#define	AES_ACCEL_SAVESTATE(name)
+#define	aes_accel_enter(savestate)
+#define	aes_accel_exit(savestate)
+#endif	/* !defined(__amd64) || !defined(_KERNEL) */
+
 typedef union {
 #ifdef	sun4u
 	uint64_t	ks64[((MAX_AES_NR) + 1) * (MAX_AES_NB)];
@@ -106,9 +154,6 @@
 	uint32_t	ks32[((MAX_AES_NR) + 1) * (MAX_AES_NB)];
 } aes_ks_t;
 
-/* aes_key.flags value: */
-#define	INTEL_AES_NI_CAPABLE	0x1	/* AES-NI instructions present */
-
 typedef struct aes_key aes_key_t;
 struct aes_key {
 	aes_ks_t	encr_ks;  /* encryption key schedule */
@@ -115,7 +160,6 @@
 	aes_ks_t	decr_ks;  /* decryption key schedule */
 #ifdef __amd64
 	long double	align128; /* Align fields above for Intel AES-NI */
-	int		flags;	  /* implementation-dependent flags */
 #endif	/* __amd64 */
 	int		nr;	  /* number of rounds (10, 12, or 14) */
 	int		type;	  /* key schedule size (32 or 64 bits) */
@@ -132,14 +176,33 @@
 	void *keysched);
 extern int aes_encrypt_block(const void *ks, const uint8_t *pt, uint8_t *ct);
 extern int aes_decrypt_block(const void *ks, const uint8_t *ct, uint8_t *pt);
+extern int aes_encrypt_ecb(const void *ks, const uint8_t *pt, uint8_t *ct,
+    uint64_t length);
+extern int aes_decrypt_ecb(const void *ks, const uint8_t *pt, uint8_t *ct,
+    uint64_t length);
+extern int aes_encrypt_cbc(const void *ks, const uint8_t *pt, uint8_t *ct,
+    const uint8_t *iv, uint64_t length);
+extern int aes_ctr_mode(const void *ks, const uint8_t *pt, uint8_t *ct,
+    uint64_t length, uint64_t counter[2]);
 
 /*
  * AES mode functions.
  * The first 2 functions operate on 16-byte AES blocks.
  */
-extern void aes_copy_block(uint8_t *in, uint8_t *out);
-extern void aes_xor_block(uint8_t *data, uint8_t *dst);
+#ifdef	__amd64
+#define	AES_COPY_BLOCK	aes_copy_intel
+#define	AES_XOR_BLOCK	aes_xor_intel
+extern void aes_copy_intel(const uint8_t *src, uint8_t *dst);
+extern void aes_xor_intel(const uint8_t *src, uint8_t *dst);
+extern void aes_xor_intel8(const uint8_t *src, uint8_t *dst);
+#else	/* !__amd64 */
+#define	AES_COPY_BLOCK	aes_copy_block
+#define	AES_XOR_BLOCK	aes_xor_block
+#endif	/* !__amd64 */
 
+extern void aes_copy_block(const uint8_t *src, uint8_t *dst);
+extern void aes_xor_block(const uint8_t *src, uint8_t *dst);
+
 /* Note: ctx is a pointer to aes_ctx_t defined in modes.h */
 extern int aes_encrypt_contiguous_blocks(void *ctx, char *data, size_t length,
     crypto_data_t *out);
@@ -146,7 +209,17 @@
 extern int aes_decrypt_contiguous_blocks(void *ctx, char *data, size_t length,
     crypto_data_t *out);
 
+#if	defined(__amd64) && defined(_KERNEL)
 /*
+ * When AES floating-point acceleration is available, these will be called
+ * by the worker functions to clear and restore floating point state and
+ * control kernel thread preemption.
+ */
+extern void aes_accel_enter(void *savestate);
+extern void aes_accel_exit(void *savestate);
+#endif	/* __amd64 && _KERNEL */
+
+/*
  * The following definitions and declarations are only used by AES FIPS POST
  */
 #ifdef _AES_IMPL
--- old/usr/src/common/crypto/aes/aes_modes.c	Thu Apr 30 20:52:29 2015
+++ new/usr/src/common/crypto/aes/aes_modes.c	Thu Apr 30 20:52:29 2015
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #include <sys/types.h>
 #include <sys/sysmacros.h>
@@ -31,45 +34,79 @@
 #include <stdlib.h>
 #endif	/* !_KERNEL */
 
+#if defined(__amd64)
 
+/*
+ * XORs a range of contiguous AES blocks in `data' with blocks in 'dst'
+ * and places the result in `dst'. On x86-64 this exploits the 128-bit
+ * floating point registers (xmm) to maximize performance.
+ */
+static void
+aes_xor_range(const uint8_t *data, uint8_t *dst, uint64_t length)
+{
+	uint64_t i = 0;
+
+	/* First use the unrolled version. */
+	for (; i + 8 * AES_BLOCK_LEN <= length; i += 8 * AES_BLOCK_LEN)
+		aes_xor_intel8(&data[i], &dst[i]);
+	/* Finish the rest in single blocks. */
+	for (; i < length; i += AES_BLOCK_LEN)
+		aes_xor_intel(&data[i], &dst[i]);
+}
+
+#else	/* !__amd64 */
+
+/*
+ * XORs a range of contiguous AES blocks in `data' with blocks in 'dst'
+ * and places the result in `dst'.
+ */
+static void
+aes_xor_range(const uint8_t *data, uint8_t *dst, uint64_t length)
+{
+	uint64_t i = 0;
+
+	if (IS_P2ALIGNED2(dst, data, sizeof (uint64_t))) {
+		/* Unroll the loop to enable efficiency. */
+		for (; i + 8 * AES_BLOCK_LEN < length; i += 8 * AES_BLOCK_LEN) {
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x00], &dst[i + 0x00]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x10], &dst[i + 0x10]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x20], &dst[i + 0x20]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x30], &dst[i + 0x30]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x40], &dst[i + 0x40]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x50], &dst[i + 0x50]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x60], &dst[i + 0x60]);
+			AES_XOR_BLOCK_ALIGNED(&data[i + 0x70], &dst[i + 0x70]);
+		}
+	}
+	/* Finish the rest in single blocks. */
+	for (; i < length; i += AES_BLOCK_LEN)
+		AES_XOR_BLOCK(&data[i], &dst[i]);
+}
+
+#endif	/* !__amd64 */
+
 /* Copy a 16-byte AES block from "in" to "out" */
 void
-aes_copy_block(uint8_t *in, uint8_t *out)
+aes_copy_block(const uint8_t *in, uint8_t *out)
 {
 	if (IS_P2ALIGNED2(in, out, sizeof (uint32_t))) {
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&out[0] = *(uint32_t *)&in[0];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&out[4] = *(uint32_t *)&in[4];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&out[8] = *(uint32_t *)&in[8];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&out[12] = *(uint32_t *)&in[12];
+		AES_COPY_BLOCK_ALIGNED(in, out);
 	} else {
-		AES_COPY_BLOCK(in, out);
+		AES_COPY_BLOCK_UNALIGNED(in, out);
 	}
 }
 
-
 /* XOR a 16-byte AES block of data into dst */
 void
-aes_xor_block(uint8_t *data, uint8_t *dst)
+aes_xor_block(const uint8_t *data, uint8_t *dst)
 {
 	if (IS_P2ALIGNED2(dst, data, sizeof (uint32_t))) {
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&dst[0] ^= *(uint32_t *)&data[0];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&dst[4] ^= *(uint32_t *)&data[4];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&dst[8] ^= *(uint32_t *)&data[8];
-		/* LINTED: pointer alignment */
-		*(uint32_t *)&dst[12] ^= *(uint32_t *)&data[12];
+		AES_XOR_BLOCK_ALIGNED(data, dst);
 	} else {
-		AES_XOR_BLOCK(data, dst);
+		AES_XOR_BLOCK_UNALIGNED(data, dst);
 	}
 }
 
-
 /*
  * Encrypt multiple blocks of data according to mode.
  */
@@ -78,33 +115,46 @@
     crypto_data_t *out)
 {
 	aes_ctx_t *aes_ctx = ctx;
-	int rv;
+	int rv = CRYPTO_SUCCESS;
 
-	if (aes_ctx->ac_flags & CTR_MODE) {
-		rv = ctr_mode_contiguous_blocks(ctx, data, length, out,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
+	for (size_t i = 0; i < length; i += AES_OPSZ) {
+		size_t opsz = MIN(length - i, AES_OPSZ);
+		AES_ACCEL_SAVESTATE(savestate);
+		aes_accel_enter(savestate);
+
+		if (aes_ctx->ac_flags & CTR_MODE) {
+			rv = ctr_mode_contiguous_blocks(ctx, &data[i], opsz,
+			    out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_XOR_BLOCK, aes_ctr_mode);
 #ifdef _KERNEL
-	} else if (aes_ctx->ac_flags & CCM_MODE) {
-		rv = ccm_mode_encrypt_contiguous_blocks(ctx, data, length,
-		    out, AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
-	} else if (aes_ctx->ac_flags & (GCM_MODE|GMAC_MODE)) {
-		rv = gcm_mode_encrypt_contiguous_blocks(ctx, data, length,
-		    out, AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		} else if (aes_ctx->ac_flags & CCM_MODE) {
+			rv = ccm_mode_encrypt_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK);
+		} else if (aes_ctx->ac_flags & (GCM_MODE|GMAC_MODE)) {
+			rv = gcm_mode_encrypt_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK, aes_ctr_mode);
 #endif
-	} else if (aes_ctx->ac_flags & CBC_MODE) {
-		rv = cbc_encrypt_contiguous_blocks(ctx,
-		    data, length, out, AES_BLOCK_LEN, aes_encrypt_block,
-		    aes_copy_block, aes_xor_block);
-	} else {
-		rv = ecb_cipher_contiguous_blocks(ctx, data, length, out,
-		    AES_BLOCK_LEN, aes_encrypt_block);
+		} else if (aes_ctx->ac_flags & CBC_MODE) {
+			rv = cbc_encrypt_contiguous_blocks(ctx, &data[i], opsz,
+			    out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK, aes_encrypt_cbc);
+		} else {
+			rv = ecb_cipher_contiguous_blocks(ctx, &data[i], opsz,
+			    out, AES_BLOCK_LEN, aes_encrypt_block,
+			    aes_encrypt_ecb);
+		}
+
+		aes_accel_exit(savestate);
+
+		if (rv != CRYPTO_SUCCESS)
+				break;
 	}
+
 	return (rv);
 }
 
-
 /*
  * Decrypt multiple blocks of data according to mode.
  */
@@ -113,32 +163,48 @@
     crypto_data_t *out)
 {
 	aes_ctx_t *aes_ctx = ctx;
-	int rv;
+	int rv = CRYPTO_SUCCESS;
 
-	if (aes_ctx->ac_flags & CTR_MODE) {
-		rv = ctr_mode_contiguous_blocks(ctx, data, length, out,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
-		if (rv == CRYPTO_DATA_LEN_RANGE)
-			rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
+
+	for (size_t i = 0; i < length; i += AES_OPSZ) {
+		size_t opsz = MIN(length - i, AES_OPSZ);
+		AES_ACCEL_SAVESTATE(savestate);
+		aes_accel_enter(savestate);
+
+		if (aes_ctx->ac_flags & CTR_MODE) {
+			rv = ctr_mode_contiguous_blocks(ctx, &data[i], opsz,
+			    out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_XOR_BLOCK, aes_ctr_mode);
+			if (rv == CRYPTO_DATA_LEN_RANGE)
+				rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
 #ifdef _KERNEL
-	} else if (aes_ctx->ac_flags & CCM_MODE) {
-		rv = ccm_mode_decrypt_contiguous_blocks(ctx, data, length,
-		    out, AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
-	} else if (aes_ctx->ac_flags & (GCM_MODE|GMAC_MODE)) {
-		rv = gcm_mode_decrypt_contiguous_blocks(ctx, data, length,
-		    out, AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		} else if (aes_ctx->ac_flags & CCM_MODE) {
+			rv = ccm_mode_decrypt_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK);
+		} else if (aes_ctx->ac_flags & (GCM_MODE|GMAC_MODE)) {
+			rv = gcm_mode_decrypt_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_encrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK, aes_ctr_mode);
 #endif
-	} else if (aes_ctx->ac_flags & CBC_MODE) {
-		rv = cbc_decrypt_contiguous_blocks(ctx, data, length, out,
-		    AES_BLOCK_LEN, aes_decrypt_block, aes_copy_block,
-		    aes_xor_block);
-	} else {
-		rv = ecb_cipher_contiguous_blocks(ctx, data, length, out,
-		    AES_BLOCK_LEN, aes_decrypt_block);
-		if (rv == CRYPTO_DATA_LEN_RANGE)
-			rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
+		} else if (aes_ctx->ac_flags & CBC_MODE) {
+			rv = cbc_decrypt_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_decrypt_block,
+			    AES_COPY_BLOCK, AES_XOR_BLOCK, aes_decrypt_ecb,
+			    aes_xor_range);
+		} else {
+			rv = ecb_cipher_contiguous_blocks(ctx, &data[i],
+			    opsz, out, AES_BLOCK_LEN, aes_decrypt_block,
+			    aes_decrypt_ecb);
+			if (rv == CRYPTO_DATA_LEN_RANGE)
+				rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
+		}
+
+		aes_accel_exit(savestate);
+
+		if (rv != CRYPTO_SUCCESS)
+				break;
 	}
+
 	return (rv);
 }
